/*
    Copyright (c) 2015 digitalSTROM AG, Zurich, Switzerland

    Authors: Christian Hitz, digitalSTROM AG <christian.hitz@digitalstrom.com>
             Michael Tross, digitalSTROM AG <michael.tross@digitalstrom.com>
             Reto Flütsch, digitalSTROM AG <reto.fluetsch@digitalstrom.com>

    This file is part of vdSM.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.
    

    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vdSM. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BITSET8_H_
#define BITSET8_H_

#include "qp_port.h"

#define IsBitSet8Set(set8_, index_)     ((set8_[(index_)/8] & (1 << ((index_) & 0x7))) != 0)
#define IsBitSet8Cleared(set8_, index_) ((set8_[(index_)/8] & (1 << ((index_) & 0x7))) == 0)
#define SetBitSet8(set8_, index_)       do { \
    if (sizeof(set8_) > ((index_)/8)) { \
        set8_[(index_)/8] |= (1 << ((index_) & 0x7)); \
    } else { \
        Q_ASSERT(FALSE); \
    } \
} while (0);
#define ClearBitSet8(set8_, index_)     do { \
    if (sizeof(set8_) > ((index_)/8)) { \
        set8_[(index_)/8] &= (uint8_t)(~(1 << ((index_) & 0x7))); \
    } else { \
        Q_ASSERT(FALSE); \
    } \
} while (0);

#endif /* BITSET8_H_ */
